%define cmsfsver 1.1.8
%define vipaver 2.0.3
Summary: Linux/390 specific utilities.
Name: s390utils
Version: 1.5.3
Release: 10%{?dist}.6
Epoch: 2
License: GPL
Group: System Environment/Base
Source: s390-tools-%{version}.tar.gz
Source2: s390.sh
Source3: s390.csh
Source4: cmsfs-%{cmsfsver}.tar.gz
Source5: zfcpconf.sh
Source6: src_vipa-%{vipaver}.tar.gz
Patch1: s390-tools-1.5.0-su.patch
Patch2: s390-tools-1.5.0-fdasd-raid.patch
Patch3: s390-tools-1.5.0-fmtpercentage.patch
Patch4: s390-tools-1.5.0-subdirs.patch
Patch5: s390-tools-1.5.3-automenu.patch
Patch6: s390-tools-1.5.0-rhconf.patch
Patch7: s390-tools-1.3.1-kernheader.patch
Patch8: s390-tools-1.3.2-warnings.patch
Patch9: s390-tools-1.5.3-sysfs.patch
Patch10: s390-tools-1.5.3-lszfcp.patch
Patch11: s390-tools-1.5.3-dbginfo.patch
Patch20: cmsfs-1.1.8-kernel26.patch
Patch40: src_vipa-2.0.3.-asm.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: sysfsutils libsysfs
BuildRequires: libsysfs-devel indent zlib-devel net-snmp-devel
ExclusiveArch: s390 s390x
%define _sbindir /sbin

%description
This package contains utilities related to Linux for S/390.
The most important programs contained in this package are:

  - The cmstools suite to list, check, copy and cat files from a CMS volume.
  - chccwdev, a script to generically change attributes of a ccw device.
  - dasdfmt, which is used to low-level format eckd-dasds with
    either the classic linux disk layout or the new z/OS
    compatible disk layout.
  - dasdview, which displays DASD and VTOC information and dumps the content
    of a DASD to the console.
  - fdasd, which is used to create or modify partitions on
    eckd-dasds formatted with the z/OS compatible disk layout.
  - osasnmpd, a subagent for net-snmp to access the OSA hardware.
  - qetharp to query and purge address data in the OSA and HiperSockets hardware
  - qethconf to configure IBM QETH function IPA, VIPA and Proxy ARP.
  - src_vipa.sh to start applications using VIPA capabilities
  - tunedasd, a tool to adjust tunable parameters on DASD devices
  - vmconvert, a tool to convert vm dumps to lkcd compatible dumps.
  - vmcp, a tool to send CP commands from a Linux guest to the VM.
  - zipl, which is used to make either dasds or tapes bootable
    for system IPL or system dump.
  - zdump, which is used to retrieve system dumps from either
    tapes or dasds.

%prep
%setup -q -n s390-tools-%{version} -a 4 -a 6

# Fix to honor the silent flag for wrongly formated disks
%patch1 -p1 -b .su

# Enhancement to add raid partiton support to dasds
%patch2 -p1 -b .fdasd-raid

# Enhancement to add a percentage output bar to dasdfmt, needed for anaconda
%patch3 -p1 -b .fmtpercentage

# Limit the subdirs and tools we support
%patch4 -p1 -b .subdirs

# Patch to maintain backwards compatibility with older zipl multiboot feature
%patch5 -p1 -b .automenu

# Makefile patches
%patch6 -p1 -b .rhconf

# Patch to fix conflicting include of asm/statfs.h and bits/statfs.h
%patch7 -p1 -b .kernheader

# Patch to fix a couple of code bugs
%patch8 -p1 -b .warnings

# Patch to disable sysfs
%patch9 -p1 -b .sysfs

# Patch to make lszcfp work properly again (#210515)
%patch10 -p1 -b .lszfcp

# Patch to fix problem with missing debugfs for dbginfo.sh (#214805)
%patch11 -p1 -b .dbginfo

# build on kernel-2.6, too
%patch20 -p0 -b .cmsfs26

# Same for src_vipa
pushd src_vipa
%patch40 -p1 -b .asm
popd

%build
make

pushd cmsfs-%{cmsfsver}
./configure
make clean
make all
popd

pushd src_vipa
make clean
make src_vipa.so
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/{%{_lib},%{_libdir},sbin,bin,boot,%{_mandir}/man8,usr/sbin,etc/profile.d,%{_bindir}}
export INSTROOT=$RPM_BUILD_ROOT
%makeinstall libdir=$RPM_BUILD_ROOT/%{_lib}
install -m 644 zipl/boot/tape0.bin $RPM_BUILD_ROOT/boot/tape0
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT/etc/profile.d
install -m 755 %{SOURCE3} $RPM_BUILD_ROOT/etc/profile.d
install -m 700 %{SOURCE5} $RPM_BUILD_ROOT/%{_sbindir}

install -m 700 cmsfs-%{cmsfsver}/cmsfscat $RPM_BUILD_ROOT/%{_sbindir}
install -m 700 cmsfs-%{cmsfsver}/cmsfslst $RPM_BUILD_ROOT/%{_sbindir}
install -m 700 cmsfs-%{cmsfsver}/cmsfsvol $RPM_BUILD_ROOT/%{_sbindir}
install -m 700 cmsfs-%{cmsfsver}/cmsfscp  $RPM_BUILD_ROOT/%{_sbindir}
install -m 700 cmsfs-%{cmsfsver}/cmsfsck  $RPM_BUILD_ROOT/%{_sbindir}
install -m 644 cmsfs-%{cmsfsver}/cmsfscat.8 $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 cmsfs-%{cmsfsver}/cmsfslst.8 $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 cmsfs-%{cmsfsver}/cmsfsvol.8 $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 cmsfs-%{cmsfsver}/cmsfscp.8  $RPM_BUILD_ROOT/%{_mandir}/man8
install -m 644 cmsfs-%{cmsfsver}/cmsfsck.8  $RPM_BUILD_ROOT/%{_mandir}/man8

install -m 755 src_vipa/src_vipa.so $RPM_BUILD_ROOT/%{_libdir}
echo '#!/bin/bash' > $RPM_BUILD_ROOT/%{_bindir}/src_vipa.sh
echo 'export LD_LIBRARY_PATH=%{_libdir}:$LD_LIBRARY_PATH' >> $RPM_BUILD_ROOT/%{_bindir}/src_vipa.sh
echo 'export LD_PRELOAD=%{_libdir}/src_vipa.so' >> $RPM_BUILD_ROOT/%{_bindir}/src_vipa.sh
echo 'exec $@' >> $RPM_BUILD_ROOT/%{_bindir}/src_vipa.sh
chmod 755 $RPM_BUILD_ROOT/%{_bindir}/src_vipa.sh
install -m 644 src_vipa/src_vipa.8 $RPM_BUILD_ROOT/%{_mandir}/man8

# Install user-defined sysinit module for zfcp (#223569)
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/modules/
ln -sf %{_sbindir}/zfcpconf.sh $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/modules/zfcpconf.modules

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc cmsfs-*/README cmsfs-*/CREDITS
/boot/*
%{_sysconfdir}/sysconfig/modules/zfcpconf.modules
%{_sbindir}/*
/usr/sbin/*
%{_bindir}/*
/bin/*
%{_libdir}/*.so
%attr(755,root,root) /etc/profile.d/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man8/*

%changelog
* Mon Jan 22 2007 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10.el5.6
- Fixed problem with invisible zfcp devices after boot (#223569)

* Mon Jan 15 2007 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10.el5.5
- Extended fix for automenu bug (#202086)

* Thu Jan 11 2007 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10.el5.4
- Updated dbginfo.sh patch to final fix from IBM (#214805)

* Wed Nov 29 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10.el5.3
- Fixed problem with missing debugfs for dbginfo.sh (#214805)

* Thu Nov 09 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10.el5.2
- Fixed lszfcp bug related to sysfsutils (#210515)

* Tue Nov 07 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10.el5.1
- Removed wrong additional $ in src_vipa.sh (#213395)
- Release and Buildroot specfile fixes

* Wed Sep 13 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-10
- Needed to bump release

* Tue Sep 12 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-9
- Added libsysfs requirement (#201863)
- Fixed zipl problem with missing default target for automenus (#202086)

* Thu Aug 10 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-8
- Added missing sysfsutils requirement for lszfcp (#201863)

* Tue Jul 25 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-7
- Included zfcpdbf, dbginfo.sh and the man1 manpages to package (#184812)

* Tue Jul 18 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-6
- Disabled sysfs support due to API changes in sysfs-2.0.0

* Fri Jul 14 2006 Karsten Hopp <karsten@redhat.de> 2:1.5.3-5
- buildrequire net-snmp-devel

* Fri Jul 14 2006 Jesse Keating <jkeating@redhat.com> - 2:1.5.3-4
- rebuild
- Add missing br libsysfs-devel, indent, zlib-devel

* Wed May 17 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.3-1
- Made src_vipa build on current toolchain again

* Tue May 16 2006 Phil Knirsch <pknirsch@redhat.com>
- Update to s390-tools-1.5.3 from IBM
- Included vmconvert
- Dropped obsolete asm patch

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 2:1.5.0-2.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Mon Jan 30 2006 Phil Knirsch <pknirsch@redhat.com> 2:1.5.0-2
- Fixed problem with s390-tools-1.5.0-fdasd-raid.patch
- Don't try to remove the non empty _bindir
- Some more install cleanups

* Thu Jan 26 2006 Phil Knirsch <pknirsch@redhat.com>
- Fixed some .macro errors in zipl/boot

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Oct 20 2005 Phil Knirsch <pknirsch@redhat.com> 2:1.5.0-1
- Large update from 1.3.2 to 1.5.0
- Include osasnmpd and vmcp now by default

* Tue Sep 06 2005 Phil Knirsch <pknirsch@redhat.com> 2:1.3.2-7
- Fixed a couple of code bugs (#143808)

* Fri Jul 29 2005 Phil Knirsch <pknirsch@redhat.com> 2:1.3.2-6
- Corrected filelist for libdir to only include *.so files

* Tue Jun 21 2005 Phil Knirsch <pknirsch@redhat.com> 2:1.3.2-5
- Added src_vipa to s390utils

* Wed Mar 02 2005 Phil Knirsch <pknirsch@redhat.com> 2:1.3.2-4
- bump release and rebuild with gcc 4

* Tue Oct 26 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.2-3
- Put binaries for system recovery in /sbin again.

* Fri Oct 15 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.2-1
- Update to s390-tools-1.3.2
- Added qetharp, qethconf, ip_watcher, tunedasd and various other tools to
  improve functionality on s390(x).

* Wed Oct 06 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.1-7
- Made the raid patch less verbose (#129656)

* Thu Sep 16 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.1-6
- Added prompt=1 and timeout=15 to automatically generated menu

* Tue Aug 31 2004 Karsten Hopp <karsten@redhat.de> 2:1.3.1-5
- install zfcpconf.sh into /sbin

* Tue Aug 24 2004 Karsten Hopp <karsten@redhat.de> 2:1.3.1-4 
- add zfcpconf.sh to read /etc/zfcp.conf and configure the zfcp
  devices

* Thu Jun 24 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.1-3
- Fixed another automenu bug with dumpto and dumptofs (#113204).

* Thu Jun 17 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.1-2
- Fixed automenu patch.
- Fixed problem with installation from tape (#121788).

* Wed Jun 16 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.3.1-1
- Updated to latest upstream version s390-tools-1.3.1

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon Jun 07 2004 Karsten Hopp <karsten@redhat.com>
- add cmsfs utils

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Feb 19 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.2.4-4
- Fixed rebuilt on fc2.

* Thu Feb 19 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.2.4-3
- Fixed automenu patch, was allocating 1 line to little.

* Mon Feb 16 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.2.4-2
- rebuilt

* Mon Feb 16 2004 Phil Knirsch <pknirsch@redhat.com> 2:1.2.4-1
- Updated to latest developerworks release 1.2.4
- Disabled zfcpdump build until i find a way to build it as none-root.

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com> 2:1.2.3-3
- rebuilt

* Thu Dec 04 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.3-2
- Fixed zfcpdump build.

* Fri Nov 28 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.3-1
- New bugfix release 1.2.3 came out today, updated again.

* Wed Nov 26 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.2-1
- Updated to latest Developerworks version 1.2.2
- Cleaned up specfile and patches a little.

* Wed Nov 12 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.1-4.1
- rebuilt

* Wed Nov 12 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.1-4
- Another fix for the new automenu patch. Target was an optional parameter in
  old s390utils, provided compatibility behaviour.

* Mon Oct 20 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.1-3.1
- rebuilt

* Mon Oct 20 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.1-3
- Small fix for the new automenu patch, default section didn't work correctly

* Mon Oct 20 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.1-2.1
- rebuilt

* Fri Oct 17 2003 Phil Knirsch <pknirsch@redhat.com> 2:1.2.1-2
- Patched new zipl to be backwards compatible to old multiboot feature.

* Thu Oct  9 2003 Harald Hoyer <harald@redhat.de> 2:1.2.1-1
- second round at updating to 1.2.1

* Thu Oct 09 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- first round at updating to 1.2.1

* Sat Sep 27 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- add /boot/tape0 for .tdf tape boots

* Fri Jul 25 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- apply dasdfmt patch from 1.2.1

* Fri Jun 20 2003 Phil Knirsch <pknirsch@redhat.com> 1.1.7-1
- Updated to latest upstream version 1.1.7

* Fri May 02 2003 Pete Zaitcev <zaitcev@redhat.com> 1.1.6-7
- Fix usage of initialized permissions for bootmap.

* Tue Apr 29 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- add extra tape loader from Pete Zaitcev

* Mon Apr 14 2003 Karsten Hopp <karsten@redhat.de> 2:1.1.6-5
- drop cpint support

* Mon Mar 24 2003 Karsten Hopp <karsten@redhat.de> 1.1.6-4
- use multiboot as default
- add option to disable multiboot 

* Sat Mar 22 2003 Karsten Hopp <karsten@redhat.de> 1.1.6-3
- add multiboot patch

* Mon Mar 10 2003 Karsten Hopp <karsten@redhat.de> 1.1.6-2
- added percentage patch (used by anaconda to display progress bars)

* Thu Feb 27 2003 Phil Knirsch <pknirsch@redhat.com> 1.1.6-1
- Updated to newest upstream version 1.1.6

* Tue Feb 04 2003 Phil Knirsch <pknirsch@redhat.com> 1.1.5-1
- Updated to newest upstream version 1.1.5

* Tue Feb 04 2003 Karsten Hopp <karsten@redhat.de> 1.1.4-3
- install libraries in /lib*, not /usr/lib*, they are required
  by some tools in /sbin

* Sun Feb 02 2003 Florian La Roche <Florian.LaRoche@redhat.de>
- fix filelist to not include debug files

* Fri Jan 24 2003 Phil Knirsch <pknirsch@redhat.com> 1.1.4-1
- Updated to latest upstream version of IBM.
- Removed all unecessary patches and updated still needed patches.
- Fixed version number. Needed to introduce epoch though.
- A little specfile cleanup.
- Dropped oco-setver and oco-convert as we don't need them anymore.

* Wed Jan 22 2003 Phil Knirsch <pknirsch@redhat.com> 20020226-4
- Added ExclusiveArch tag.

* Mon Oct 21 2002 Phil Knirsch <pknirsch@redhat.com> 20020226-3
- Removed fdisk -> fdasd symlink. Is now provided by util-linux.
- Disabled f5 patch for s390x for now. Enable it later for newer kernels again.

* Mon May 27 2002 Phil Knirsch <pknirsch@redhat.com>
- Fixed dasdview to build on kernels > 2.4.18.

* Wed Apr 24 2002 Karsten Hopp <karsten@redhat.de>
- add IBM 5 patch

* Tue Jan 29 2002 Karsten Hopp <karsten@redhat.de>
- add IBM 4 patch
- add profile.d scripts to set correct TERM in 3270 console

* Thu Dec 18 2001 Karsten Hopp <karsten@redhat.de>
- add cpint programs

* Mon Nov 26 2001 Harald Hoyer <harald@redhat.de> 20011012-6
- fix for #56720

* Thu Nov 15 2001 Karsten Hopp <karsten@redhat.de>
- add fdisk - > fdasd symlink

* Thu Nov 12 2001 Karsten Hopp <karsten@redhat.de>
- add IBM patch (11/09/2001) and redo percentage patch

* Thu Nov 08 2001 Karsten Hopp <karsten@redhat.de>
- re-enable DASD if dasdfmt is interrupted with Ctrl-C

* Mon Nov 05 2001 Harald Hoyer <harald@redhat.de> 20011012-4
- added s390-tools-dasdfmt-percentage.patch

* Mon Oct 22 2001 Karsten Hopp <karsten@redhat.de>
- remove postinstall script

* Mon Oct 15 2001 Karsten Hopp <karsten@redhat.de>
- add IBM's s390-utils-2.patch
- add console to securetty

* Mon Oct 01 2001 Karsten Hopp <karsten@redhat.de>
- added oco-setkver and oco-convert

* Fri Aug 31 2001 Karsten Hopp <karsten@redhat.de>
- don't write error message in silent mode

* Thu Aug 23 2001 Harald Hoyer <harald@redhat.de>
- added s390-tools-dasdfmt-status.patch

* Tue Aug 21 2001 Karsten Hopp <karsten@redhat.de>
- update to the version from Aug 20

* Tue Aug 14 2001 Karsten Hopp <karsten@redhat.de>
- fix permissions

* Mon Aug 13 2001 Karsten Hopp <karsten@redhat.de>
- rename package to s390utils. s390-tools is no longer needed.

* Thu Aug 02 2001 Karsten Hopp <karsten@redhat.de>
- initial build


